<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleSlidingMass.m</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleSlidingMass_8m-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleSlidingMass.m</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is Moco's simplest example.</p>
<div class="fragment"><div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line">% <a class="code" href="namespaceOpenSim.html">OpenSim</a> Moco: exampleSlidingMass.m                                         %</div>
<div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line">% Copyright (c) 2017 Stanford University and the Authors                     %</div>
<div class="line">%                                                                            %</div>
<div class="line">% Author(s): Christopher Dembia                                              %</div>
<div class="line">%                                                                            %</div>
<div class="line">% Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    %</div>
<div class="line">% not use <span class="keyword">this</span> file except in compliance with the License. You may obtain a  %</div>
<div class="line">% copy of the License at http:<span class="comment">//www.apache.org/licenses/LICENSE-2.0          %</span></div>
<div class="line">%                                                                            %</div>
<div class="line">% Unless required by applicable law or agreed to in writing, software        %</div>
<div class="line">% distributed under the License is distributed on an <span class="stringliteral">&quot;AS IS&quot;</span> BASIS,          %</div>
<div class="line">% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   %</div>
<div class="line">% See the License <span class="keywordflow">for</span> the specific language governing permissions and        %</div>
<div class="line">% limitations under the License.                                             %</div>
<div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line"> </div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">model = Model();</div>
<div class="line">model.setName(<span class="stringliteral">&#39;sliding_mass&#39;</span>);</div>
<div class="line">model.set_gravity(Vec3(0, 0, 0));</div>
<div class="line">body = Body(<span class="stringliteral">&#39;body&#39;</span>, 2.0, Vec3(0), Inertia(0));</div>
<div class="line">model.addComponent(body);</div>
<div class="line"> </div>
<div class="line">% Allows translation along x.</div>
<div class="line">joint = SliderJoint(<span class="stringliteral">&#39;slider&#39;</span>, model.getGround(), body);</div>
<div class="line">coord = joint.updCoordinate();</div>
<div class="line">coord.setName(<span class="stringliteral">&#39;position&#39;</span>);</div>
<div class="line">model.addComponent(joint);</div>
<div class="line"> </div>
<div class="line">actu = CoordinateActuator();</div>
<div class="line">actu.setCoordinate(coord);</div>
<div class="line">actu.setName(<span class="stringliteral">&#39;actuator&#39;</span>);</div>
<div class="line">actu.setOptimalForce(1);</div>
<div class="line">model.addComponent(actu);</div>
<div class="line"> </div>
<div class="line">body.attachGeometry(Sphere(0.05));</div>
<div class="line"> </div>
<div class="line">model.finalizeConnections();</div>
<div class="line"> </div>
<div class="line">% Create MocoStudy.</div>
<div class="line">% ================</div>
<div class="line">study = MocoStudy();</div>
<div class="line">study.setName(<span class="stringliteral">&#39;sliding_mass&#39;</span>);</div>
<div class="line"> </div>
<div class="line">% Define the optimal control problem.</div>
<div class="line">% ===================================</div>
<div class="line">problem = study.updProblem();</div>
<div class="line"> </div>
<div class="line">% Model (dynamics).</div>
<div class="line">% -----------------</div>
<div class="line">problem.setModel(model);</div>
<div class="line"> </div>
<div class="line">% Bounds.</div>
<div class="line">% -------</div>
<div class="line">% Initial time must be 0, final time can be within [0, 5].</div>
<div class="line">problem.setTimeBounds(MocoInitialBounds(0.), MocoFinalBounds(0., 5.));</div>
<div class="line"> </div>
<div class="line">% <a class="code" href="namespaceOpenSim.html#a4286a47452ef915e89270cee497faaeca52f5e0bc3859bc5f5e25130b6c7e8881">Position</a> must be within [-5, 5] throughout the motion.</div>
<div class="line">% Initial position must be 0, <span class="keyword">final</span> position must be 1.</div>
<div class="line">problem.setStateInfo(<span class="stringliteral">&#39;/slider/position/value&#39;</span>, MocoBounds(-5, 5), ...</div>
<div class="line">    MocoInitialBounds(0), MocoFinalBounds(1));</div>
<div class="line">% Speed must be within [-50, 50] throughout the motion.</div>
<div class="line">% Initial and <span class="keyword">final</span> speed must be 0. Use compact syntax.</div>
<div class="line">problem.setStateInfo(<span class="stringliteral">&#39;/slider/position/speed&#39;</span>, [-50, 50], [0], [0]);</div>
<div class="line"> </div>
<div class="line">% Applied force must be between -50 and 50.</div>
<div class="line">problem.setControlInfo(&#39;/actuator&#39;, MocoBounds(-50, 50));</div>
<div class="line"> </div>
<div class="line">% Cost.</div>
<div class="line">% -----</div>
<div class="line">problem.addGoal(MocoFinalTimeGoal(&#39;final_time&#39;));</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Configure the solver.</div>
<div class="line">% =====================</div>
<div class="line">solver = study.initCasADiSolver();</div>
<div class="line">solver.set_num_mesh_intervals(50);</div>
<div class="line"> </div>
<div class="line">% Now that we<span class="stringliteral">&#39;ve finished setting up the tool, print it to a file.</span></div>
<div class="line"><span class="stringliteral">study.print(&#39;</span>sliding_mass.omoco<span class="stringliteral">&#39;);</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">% Solve the problem.</span></div>
<div class="line"><span class="stringliteral">% ==================</span></div>
<div class="line"><span class="stringliteral">solution = study.solve();</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">solution.write(&#39;</span>sliding_mass_solution.sto<span class="stringliteral">&#39;);</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">% The following environment variable is set during automated testing.</span></div>
<div class="line"><span class="stringliteral">if ~strcmp(getenv(&#39;</span>OPENSIM_USE_VISUALIZER<span class="stringliteral">&#39;), &#39;</span>0<span class="stringliteral">&#39;)</span></div>
<div class="line"><span class="stringliteral">    study.visualize(solution);</span></div>
<div class="line"><span class="stringliteral">    plot(solution.getTimeMat(), solution.getStatesTrajectoryMat());</span></div>
<div class="line"><span class="stringliteral">    xlabel(&#39;</span>time (s)<span class="stringliteral">&#39;);</span></div>
<div class="line"><span class="stringliteral">    ylabel(&#39;</span>states<span class="stringliteral">&#39;);</span></div>
<div class="line"><span class="stringliteral">    legend(&#39;</span>/slider/position/value<span class="stringliteral">&#39;, &#39;</span>/slider/position/speed<span class="stringliteral">&#39;);</span></div>
<div class="line"><span class="stringliteral">end</span></div>
<div class="ttc" id="anamespaceOpenSim_html"><div class="ttname"><a href="namespaceOpenSim.html">OpenSim</a></div><div class="ttdoc">The Moco interface is contained within the OpenSim namespace.</div><div class="ttdef"><b>Definition:</b> ActivationCoordinateActuator.h:30</div></div>
<div class="ttc" id="anamespaceOpenSim_html_a4286a47452ef915e89270cee497faaeca52f5e0bc3859bc5f5e25130b6c7e8881"><div class="ttname"><a href="namespaceOpenSim.html#a4286a47452ef915e89270cee497faaeca52f5e0bc3859bc5f5e25130b6c7e8881">OpenSim::KinematicLevel::Position</a></div><div class="ttdeci">@ Position</div></div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:39 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
